<?php
///////////////////////////////////////////////////////// 
//      Этот плагин сгенерирован автоматически     	   // 
//      генератор написал stroller7@gmail.com		   // 
///////////////////////////////////////////////////////// 

class p_notification_Birthday extends cmsPlugin { 

// ==================================================================== // 

	public function __construct(){ 


		
		// Информация о плагине
		$this->info['plugin']          	= 'p_notification_Birthday';
		$this->info['title']       		= 'Уведомление о Дне рождения';
		$this->info['description']     	= 'Друзьям именинника отправляется письмо с напоминанием';
		$this->info['author']      		= 'stroller7@gmail.com';
		$this->info['version']     		= '1.0'; 

		global $_LANG;
		
		// Настройки по-умолчанию
        // Ключи массива должны быть латиницей в верхнем регистре
        // если вы хотите, чтобы название опций было на нужном вам языке
        // создайте соответствующий lang файл, например /languages/ru/plugins/p_notification_Birthday.php
        // ключи языковых переменных должны совпадать с ключами массива конфигурации
		// добавьте после следующей строчки еще, если нужно
		$this->config['PLUGIN_GREETING_TIME']    = '8:00'; 
		$this->config['PLUGIN_SHOWBIRTH']    = 'Да';


		// События, которые будут отлавливаться плагином. 
		// Вставьте в компонент или модуль строчку типа
		// $items = cmsCore::callEvent('HAPPY_BIRTHDAY', $items);
		$this->events[]                 = 'HAPPY_BIRTHDAY'; 

		
		parent::__construct(); 

	} 


// ==================================================================== // 

	 /**
     * Процедура установки плагина
     * @return bool
     */ 
	 public function install(){
		return parent::install();
	} 


// ==================================================================== // 

	 /**
     * Процедура обновления плагина
     * @return bool
     */
    public function upgrade(){
		return parent::upgrade();
	} 


// ==================================================================== // 

	/**
     * Обработка событий
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
	 public function execute($event='', $item=array()){
		parent::execute();
		// если событий, обрабатываемых плагином несколько, добавьте строчку case в этот оператор switch
		// не забудьте, что каждая строчка вызывает свой индивидуальный метод! 
		// эти методы вы описали в поле Методы, когда использовали утилиту
		switch ($event){ 
			case 'HAPPY_BIRTHDAY': $item = $this->notificationBirthday($item); break; 

		}
		return $item;
	 } 


	
// ==================================================================== // 

	// Здесь тело метода, вызываемого оператором switch
	private function notificationBirthday($item) { 

		$inCore     = cmsCore::getInstance();
		$inConf 	= cmsConfig::getInstance();
		global $_LANG; 

		// Получаю час и минуту для записи на стену
		$time = explode(':', $this->config['PLUGIN_GREETING_TIME']);
		$hour = $time[0];
		$minute = $time[1];
		// Получаю метки времени:
		// начала текущих суток, 
		$mkstart = mktime(0, 0, 0, date("m"), date("d"), date("Y"));
		// конца текущих суток, 
		$mkfinish = mktime(23, 59, 59, date("m"), date("d"), date("Y"));
		// метка, когда надо вставить поздравление на стену
		$mkpost = mktime($hour, $minute, 0, date("m"), date("d"), date("Y"));
		
		// Формат лога:
		// метка времени | id имениника | login имениника
		// Путь к логу
		$log_path = '/plugins/p_notification_Birthday/timer/timer.log';
		
		// Просматриваю лог и удаляю все старые записи (больше суток)
		$lines = file(PATH.$log_path);
		foreach($lines as $n=>$line){
			$item = explode(' | ', rtrim($line));
			if($line == ''){unset($lines[$n]);}
			if($item[0] < $mkstart){unset($lines[$n]);}
		}
		// Записываю лог обратно
		$fd = fopen(PATH.$log_path, "w");
		foreach($lines as $line){
			fwrite($fd, $line."\r\n");
		}
		fclose($fd);
		
		// Просматриваю лог на предмет записей
		$lines = file(PATH.$log_path);
		foreach($lines as $n=>$line){
			if($line){$item = explode(' | ', rtrim($line));	}
				if($item[0]){$record[$item[1]] = 1;}else{$record[$item[1]] = 0;}
		}
		// Проверяю, включено ли разрешение поздравлять друзей, если имениник запретил показывать свой ДР
		$plugin_allowed = mb_strtolower($this->config['PLUGIN_SHOWBIRTH'], 'UTF-8');
				if( $plugin_allowed == 'да' || $plugin_allowed == 'yes' || $plugin_allowed == '1'){
					$is_allowed = 1;
				}else{$is_allowed = 0;}
		// Получаю именников, если наступило время поздравления и запись о поздравлении отсутствует в логе
		if(time() > $mkpost && !$record){
			$now = date("Y-m-d H:i:s");		
			$sql = "SELECT id, nickname, login FROM `cms_users` WHERE DAY(birthdate)=DAY(CURDATE()) && MONTH(birthdate)=MONTH(CURDATE()) ";
			$result = $this->inDB->query($sql);
			if ($this->inDB->num_rows($result)){
				while($notation = $this->inDB->fetch_assoc($result)){
					$birthday_list[] = $notation;
				}
			}	
		}
		// Получаю id друзей именинника 
			foreach($birthday_list as $birthday_man){
				// Проверяю, разрешил ли юзер показывать свой ДР в профиле
				$is_showbirth = $this->inDB->get_field('cms_user_profiles', "id = {$birthday_man['id']}", 'showbirth');
				if($is_allowed){$allowed = 1;}else{
					if($is_showbirth){$allowed = 1;}
					else{$allowed = 0;}
				}
				if($allowed){
					$sql = "SELECT to_id FROM `cms_user_friends` WHERE from_id = {$birthday_man['id']} AND is_accepted = 1";
					$result = $this->inDB->query($sql);
					if ($this->inDB->num_rows($result)){
						while($entry = $this->inDB->fetch_assoc($result)){
							$friends_list[] = $entry['to_id'];
						}
					}
					// по id друга получаю его ник и емейл
					foreach($friends_list as $id){
						$friend = $this->inDB->get_fields('cms_users', "id={$id}", 'nickname, email');
						// Формирую текст письма
						$text = cmsCore::getLanguageTextFile('your_friend_birthday');
						$text = str_replace('{friend_nick}', $friend['nickname'], $text);
						$text = str_replace('{celebrator_login}', 'http://'.$_SERVER['HTTP_HOST'].'/users/'.$birthday_man['login'], $text);
						$text = str_replace('{celebrator}', $birthday_man['nickname'], $text);
						$text = str_replace('{sitename}', $inConf->sitename, $text); 
						$text = str_replace('{sitedomain}', 'http://'.$_SERVER['HTTP_HOST'], $text);
						// Отправляю письмо
						cmsCore::getInstance()->mailText($friend['email'], $_LANG['LETTER_SUBJECT'], $text);
					}
				}				
			}
			
		// Записываю именников в лог
		if($birthday_list){
			$fd = fopen(PATH.$log_path, "a");
			foreach($birthday_list as $user){
				$item = array(0=>time(), 1=>$user['id'], 2=>$user['login']);
				$string = implode(' | ', $item);
				fwrite($fd, $string."\r\n");
			}
			fclose($fd);
		}
		
		return $item;
	}
	
// ==================================================================== // 

}
?>
	